"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PlayerProfile = exports.RegistrationWithGames = exports.RegistrationAccount = exports.GameRegistration = exports.GameBundle = exports.GameAccount = exports.Vote = exports.PlayerDeposit = exports.ServerJoin = exports.PlayerJoin = exports.ServerAccount = exports.TokenWithBalance = exports.Token = exports.VoteType = void 0;
const borsh_1 = require("@race-foundation/borsh");
var VoteType;
(function (VoteType) {
    VoteType[VoteType["ServerVoteTransactorDropOff"] = 0] = "ServerVoteTransactorDropOff";
    VoteType[VoteType["ClientVoteTransactorDropOff"] = 1] = "ClientVoteTransactorDropOff";
})(VoteType = exports.VoteType || (exports.VoteType = {}));
class Token {
    constructor(fields) {
        Object.assign(this, fields);
    }
}
exports.Token = Token;
class TokenWithBalance {
    constructor(token, amount) {
        Object.assign(this, token);
        this.amount = amount;
        this.uiAmount = (Number(amount) / Math.pow(10, token.decimals)).toLocaleString();
    }
}
exports.TokenWithBalance = TokenWithBalance;
class ServerAccount {
    constructor(fields) {
        Object.assign(this, fields);
    }
}
__decorate([
    (0, borsh_1.field)('string')
], ServerAccount.prototype, "addr", void 0);
__decorate([
    (0, borsh_1.field)('string')
], ServerAccount.prototype, "endpoint", void 0);
exports.ServerAccount = ServerAccount;
class PlayerJoin {
    constructor(fields) {
        Object.assign(this, fields);
    }
}
__decorate([
    (0, borsh_1.field)('string')
], PlayerJoin.prototype, "addr", void 0);
__decorate([
    (0, borsh_1.field)('u16')
], PlayerJoin.prototype, "position", void 0);
__decorate([
    (0, borsh_1.field)('u64')
], PlayerJoin.prototype, "balance", void 0);
__decorate([
    (0, borsh_1.field)('u64')
], PlayerJoin.prototype, "accessVersion", void 0);
__decorate([
    (0, borsh_1.field)('string')
], PlayerJoin.prototype, "verifyKey", void 0);
exports.PlayerJoin = PlayerJoin;
class ServerJoin {
    constructor(fields) {
        Object.assign(this, fields);
    }
}
__decorate([
    (0, borsh_1.field)('string')
], ServerJoin.prototype, "addr", void 0);
__decorate([
    (0, borsh_1.field)('string')
], ServerJoin.prototype, "endpoint", void 0);
__decorate([
    (0, borsh_1.field)('u64')
], ServerJoin.prototype, "accessVersion", void 0);
__decorate([
    (0, borsh_1.field)('string')
], ServerJoin.prototype, "verifyKey", void 0);
exports.ServerJoin = ServerJoin;
class PlayerDeposit {
    constructor(fields) {
        Object.assign(this, fields);
    }
}
__decorate([
    (0, borsh_1.field)('string')
], PlayerDeposit.prototype, "addr", void 0);
__decorate([
    (0, borsh_1.field)('u64')
], PlayerDeposit.prototype, "amount", void 0);
__decorate([
    (0, borsh_1.field)('u64')
], PlayerDeposit.prototype, "settleVersion", void 0);
exports.PlayerDeposit = PlayerDeposit;
class Vote {
    constructor(fields) {
        Object.assign(this, fields);
    }
}
__decorate([
    (0, borsh_1.field)('string')
], Vote.prototype, "voter", void 0);
__decorate([
    (0, borsh_1.field)('string')
], Vote.prototype, "votee", void 0);
__decorate([
    (0, borsh_1.field)('u8')
], Vote.prototype, "voteType", void 0);
exports.Vote = Vote;
class GameAccount {
    constructor(fields) {
        Object.assign(this, fields);
    }
}
__decorate([
    (0, borsh_1.field)('string')
], GameAccount.prototype, "addr", void 0);
__decorate([
    (0, borsh_1.field)('string')
], GameAccount.prototype, "title", void 0);
__decorate([
    (0, borsh_1.field)('string')
], GameAccount.prototype, "bundleAddr", void 0);
__decorate([
    (0, borsh_1.field)('string')
], GameAccount.prototype, "tokenAddr", void 0);
__decorate([
    (0, borsh_1.field)('string')
], GameAccount.prototype, "ownerAddr", void 0);
__decorate([
    (0, borsh_1.field)('u64')
], GameAccount.prototype, "settleVersion", void 0);
__decorate([
    (0, borsh_1.field)('u64')
], GameAccount.prototype, "accessVersion", void 0);
__decorate([
    (0, borsh_1.field)((0, borsh_1.array)((0, borsh_1.struct)(PlayerJoin)))
], GameAccount.prototype, "players", void 0);
__decorate([
    (0, borsh_1.field)((0, borsh_1.array)((0, borsh_1.struct)(PlayerDeposit)))
], GameAccount.prototype, "deposits", void 0);
__decorate([
    (0, borsh_1.field)((0, borsh_1.array)((0, borsh_1.struct)(ServerJoin)))
], GameAccount.prototype, "servers", void 0);
__decorate([
    (0, borsh_1.field)((0, borsh_1.option)('string'))
], GameAccount.prototype, "transactorAddr", void 0);
__decorate([
    (0, borsh_1.field)((0, borsh_1.array)((0, borsh_1.struct)(Vote)))
], GameAccount.prototype, "votes", void 0);
__decorate([
    (0, borsh_1.field)((0, borsh_1.option)('u64'))
], GameAccount.prototype, "unlockTime", void 0);
__decorate([
    (0, borsh_1.field)('u16')
], GameAccount.prototype, "maxPlayers", void 0);
__decorate([
    (0, borsh_1.field)('u64')
], GameAccount.prototype, "minDeposit", void 0);
__decorate([
    (0, borsh_1.field)('u64')
], GameAccount.prototype, "maxDeposit", void 0);
__decorate([
    (0, borsh_1.field)('u32')
], GameAccount.prototype, "dataLen", void 0);
__decorate([
    (0, borsh_1.field)('u8-array')
], GameAccount.prototype, "data", void 0);
exports.GameAccount = GameAccount;
class GameBundle {
    constructor(fields) {
        Object.assign(this, fields);
    }
}
__decorate([
    (0, borsh_1.field)('string')
], GameBundle.prototype, "uri", void 0);
__decorate([
    (0, borsh_1.field)('string')
], GameBundle.prototype, "name", void 0);
__decorate([
    (0, borsh_1.field)('u8-array')
], GameBundle.prototype, "data", void 0);
exports.GameBundle = GameBundle;
class GameRegistration {
    constructor(fields) {
        Object.assign(this, fields);
    }
}
__decorate([
    (0, borsh_1.field)('string')
], GameRegistration.prototype, "title", void 0);
__decorate([
    (0, borsh_1.field)('string')
], GameRegistration.prototype, "addr", void 0);
__decorate([
    (0, borsh_1.field)('u64')
], GameRegistration.prototype, "regTime", void 0);
__decorate([
    (0, borsh_1.field)('string')
], GameRegistration.prototype, "bundleAddr", void 0);
exports.GameRegistration = GameRegistration;
class RegistrationAccount {
    constructor(fields) {
        Object.assign(this, fields);
    }
}
__decorate([
    (0, borsh_1.field)('string')
], RegistrationAccount.prototype, "addr", void 0);
__decorate([
    (0, borsh_1.field)('bool')
], RegistrationAccount.prototype, "isPrivate", void 0);
__decorate([
    (0, borsh_1.field)('u16')
], RegistrationAccount.prototype, "size", void 0);
__decorate([
    (0, borsh_1.field)((0, borsh_1.option)('string'))
], RegistrationAccount.prototype, "owner", void 0);
__decorate([
    (0, borsh_1.field)((0, borsh_1.array)((0, borsh_1.struct)(GameRegistration)))
], RegistrationAccount.prototype, "games", void 0);
exports.RegistrationAccount = RegistrationAccount;
/**
 * The registration account data with games consolidated.
 */
class RegistrationWithGames {
    constructor(fields) {
        Object.assign(this, fields);
    }
}
exports.RegistrationWithGames = RegistrationWithGames;
class PlayerProfile {
    constructor(fields) {
        Object.assign(this, fields);
    }
}
__decorate([
    (0, borsh_1.field)('string')
], PlayerProfile.prototype, "addr", void 0);
__decorate([
    (0, borsh_1.field)('string')
], PlayerProfile.prototype, "nick", void 0);
__decorate([
    (0, borsh_1.field)((0, borsh_1.option)('string'))
], PlayerProfile.prototype, "pfp", void 0);
exports.PlayerProfile = PlayerProfile;
//# sourceMappingURL=accounts.js.map