"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _Connection_playerAddr, _Connection_endpoint, _Connection_encryptor, _Connection_socket;
Object.defineProperty(exports, "__esModule", { value: true });
exports.Connection = exports.BroadcastFrameMessage = exports.BroadcastFrameInit = exports.BroadcastFrameEvent = exports.BroadcastFrame = exports.Message = exports.SubmitMessageParams = exports.SubmitEventParams = exports.SubscribeEventParams = exports.ExitGameParams = exports.AttachGameParams = void 0;
const encryptor_1 = require("./encryptor");
const events_1 = require("./events");
const borsh_1 = require("@race-foundation/borsh");
const utils_1 = require("./utils");
class AttachGameParams {
    constructor(fields) {
        this.key = fields.key;
        this.signer = fields.signer;
    }
}
__decorate([
    (0, borsh_1.field)('string')
], AttachGameParams.prototype, "signer", void 0);
__decorate([
    (0, borsh_1.field)((0, borsh_1.struct)(encryptor_1.PublicKeyRaws))
], AttachGameParams.prototype, "key", void 0);
exports.AttachGameParams = AttachGameParams;
class ExitGameParams {
}
exports.ExitGameParams = ExitGameParams;
class SubscribeEventParams {
    constructor(fields) {
        this.settleVersion = fields.settleVersion;
    }
}
__decorate([
    (0, borsh_1.field)('u64')
], SubscribeEventParams.prototype, "settleVersion", void 0);
exports.SubscribeEventParams = SubscribeEventParams;
class SubmitEventParams {
    constructor(fields) {
        this.event = fields.event;
    }
}
__decorate([
    (0, borsh_1.field)((0, borsh_1.enums)(events_1.GameEvent))
], SubmitEventParams.prototype, "event", void 0);
exports.SubmitEventParams = SubmitEventParams;
class SubmitMessageParams {
    constructor(fields) {
        this.content = fields.content;
    }
}
__decorate([
    (0, borsh_1.field)('string')
], SubmitMessageParams.prototype, "content", void 0);
exports.SubmitMessageParams = SubmitMessageParams;
class Message {
    constructor(fields) {
        Object.assign(this, fields);
    }
}
__decorate([
    (0, borsh_1.field)('string')
], Message.prototype, "sender", void 0);
__decorate([
    (0, borsh_1.field)('string')
], Message.prototype, "content", void 0);
exports.Message = Message;
class BroadcastFrame {
}
exports.BroadcastFrame = BroadcastFrame;
let BroadcastFrameEvent = class BroadcastFrameEvent extends BroadcastFrame {
    constructor(fields) {
        super();
        Object.assign(this, fields);
    }
};
__decorate([
    (0, borsh_1.field)('string')
], BroadcastFrameEvent.prototype, "gameAddr", void 0);
__decorate([
    (0, borsh_1.field)((0, borsh_1.enums)(events_1.GameEvent))
], BroadcastFrameEvent.prototype, "event", void 0);
__decorate([
    (0, borsh_1.field)('u64')
], BroadcastFrameEvent.prototype, "timestamp", void 0);
BroadcastFrameEvent = __decorate([
    (0, borsh_1.variant)(0)
], BroadcastFrameEvent);
exports.BroadcastFrameEvent = BroadcastFrameEvent;
let BroadcastFrameInit = class BroadcastFrameInit extends BroadcastFrame {
    constructor(fields) {
        super();
        Object.assign(this, fields);
    }
};
__decorate([
    (0, borsh_1.field)('string')
], BroadcastFrameInit.prototype, "gameAddr", void 0);
__decorate([
    (0, borsh_1.field)('u64')
], BroadcastFrameInit.prototype, "accessVersion", void 0);
__decorate([
    (0, borsh_1.field)('u64')
], BroadcastFrameInit.prototype, "settleVersion", void 0);
__decorate([
    (0, borsh_1.field)('u8-array')
], BroadcastFrameInit.prototype, "checkpointState", void 0);
BroadcastFrameInit = __decorate([
    (0, borsh_1.variant)(1)
], BroadcastFrameInit);
exports.BroadcastFrameInit = BroadcastFrameInit;
let BroadcastFrameMessage = class BroadcastFrameMessage extends BroadcastFrame {
    constructor(fields) {
        super();
        Object.assign(this, fields);
    }
};
__decorate([
    (0, borsh_1.field)('string')
], BroadcastFrameMessage.prototype, "gameAddr", void 0);
__decorate([
    (0, borsh_1.field)((0, borsh_1.struct)(Message))
], BroadcastFrameMessage.prototype, "message", void 0);
BroadcastFrameMessage = __decorate([
    (0, borsh_1.variant)(2)
], BroadcastFrameMessage);
exports.BroadcastFrameMessage = BroadcastFrameMessage;
function* EventStream() { }
class Connection {
    constructor(playerAddr, endpoint, encryptor) {
        _Connection_playerAddr.set(this, void 0);
        _Connection_endpoint.set(this, void 0);
        _Connection_encryptor.set(this, void 0);
        _Connection_socket.set(this, void 0);
        __classPrivateFieldSet(this, _Connection_playerAddr, playerAddr, "f");
        __classPrivateFieldSet(this, _Connection_endpoint, endpoint, "f");
        __classPrivateFieldSet(this, _Connection_encryptor, encryptor, "f");
        const socket = new WebSocket(endpoint);
        __classPrivateFieldSet(this, _Connection_socket, socket, "f");
    }
    async attachGame(gameAddr, params) {
        const req = this.makeReqNoSig(gameAddr, 'attach_game', params);
        await this.requestXhr(req);
    }
    async submitEvent(gameAddr, params) {
        const req = await this.makeReq(gameAddr, 'submit_event', params);
        await this.requestXhr(req);
    }
    async submitMessage(gameAddr, params) {
        const req = await this.makeReq(gameAddr, 'submit_message', params);
        await this.requestXhr(req);
    }
    async exitGame(gameAddr, params) {
        const req = await this.makeReq(gameAddr, 'exit_game', params);
        await this.requestXhr(req);
    }
    async *subscribeEvents(gameAddr, params) {
        const req = this.makeReqNoSig(gameAddr, 'subscribe_event', params);
        await this.requestWs(req);
        let messageQueue = [];
        let resolve;
        let messagePromise = new Promise(r => (resolve = r));
        __classPrivateFieldGet(this, _Connection_socket, "f").onmessage = msg => {
            if (resolve !== undefined) {
                let frame = this.parseEventMessage(msg.data);
                if (frame !== undefined) {
                    let r = resolve;
                    resolve = undefined;
                    r(frame);
                }
            }
            else {
                let frame = this.parseEventMessage(msg.data);
                if (frame !== undefined) {
                    messageQueue.push(frame);
                }
            }
        };
        __classPrivateFieldGet(this, _Connection_socket, "f").onclose = () => {
            if (resolve !== undefined) {
                let r = resolve;
                resolve = undefined;
                r(undefined);
            }
        };
        while (true) {
            if (messageQueue.length > 0) {
                yield messageQueue.shift();
            }
            else {
                // await new Promise(resolve => setTimeout(() => resolve(undefined), 100));
                // const p = messagePromise;
                // messagePromise = new Promise<BroadcastFrame | undefined>(r => (resolve = r));
                // yield p;
                yield messagePromise;
                messagePromise = new Promise(r => (resolve = r));
            }
        }
    }
    parseEventMessage(raw) {
        let resp = JSON.parse(raw);
        if (resp.method === 's_event') {
            let result = resp.params.result;
            let data = (0, utils_1.base64ToUint8Array)(result);
            let frame = (0, borsh_1.deserialize)(BroadcastFrame, data);
            return frame;
        }
        else {
            return undefined;
        }
    }
    static initialize(playerAddr, endpoint, encryptor) {
        return new Connection(playerAddr, endpoint, encryptor);
    }
    async makeReq(gameAddr, method, params) {
        const paramsBytes = (0, borsh_1.serialize)(params);
        const sig = await __classPrivateFieldGet(this, _Connection_encryptor, "f").sign(paramsBytes, __classPrivateFieldGet(this, _Connection_playerAddr, "f"));
        const sigBytes = (0, borsh_1.serialize)(sig);
        return JSON.stringify({
            jsonrpc: '2.0',
            method,
            id: crypto.randomUUID(),
            params: [gameAddr, (0, utils_1.arrayBufferToBase64)(paramsBytes), (0, utils_1.arrayBufferToBase64)(sigBytes)],
        });
    }
    makeReqNoSig(gameAddr, method, params) {
        const paramsBytes = (0, borsh_1.serialize)(params);
        return JSON.stringify({
            jsonrpc: '2.0',
            method,
            id: crypto.randomUUID(),
            params: [gameAddr, (0, utils_1.arrayBufferToBase64)(paramsBytes)],
        });
    }
    async requestWs(req) {
        try {
            await this.waitSocketReady();
            __classPrivateFieldGet(this, _Connection_socket, "f").send(req);
        }
        catch (err) {
            console.error('Failed to connect to current transactor: ' + __classPrivateFieldGet(this, _Connection_endpoint, "f"));
            throw err;
        }
    }
    async requestXhr(req) {
        try {
            const resp = await fetch(__classPrivateFieldGet(this, _Connection_endpoint, "f").replace(/^ws/, 'http'), {
                method: 'POST',
                body: req,
                headers: {
                    'Content-Type': 'application/json',
                },
            });
            if (resp.ok) {
                return resp.json();
            }
            else {
                throw Error('Transactor request failed:' + resp.json());
            }
        }
        catch (err) {
            console.error('Failed to connect to current transactor: ' + __classPrivateFieldGet(this, _Connection_endpoint, "f"));
            throw err;
        }
    }
    waitSocketReady() {
        return new Promise((resolve, reject) => {
            let maxAttempts = 10;
            let intervalTime = 200;
            let currAttempt = 0;
            const interval = setInterval(() => {
                if (currAttempt > maxAttempts) {
                    clearInterval(interval);
                    reject();
                }
                else if (__classPrivateFieldGet(this, _Connection_socket, "f").readyState === __classPrivateFieldGet(this, _Connection_socket, "f").OPEN) {
                    clearInterval(interval);
                    resolve(undefined);
                }
                currAttempt++;
            }, intervalTime);
        });
    }
}
exports.Connection = Connection;
_Connection_playerAddr = new WeakMap(), _Connection_endpoint = new WeakMap(), _Connection_encryptor = new WeakMap(), _Connection_socket = new WeakMap();
//# sourceMappingURL=connection.js.map