"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Effect = exports.ActionTimeout = exports.Release = exports.Reveal = exports.Assign = exports.Ask = exports.Settle = exports.SettleEject = exports.SettleSub = exports.SettleAdd = exports.SettleOp = void 0;
const random_state_1 = require("./random-state");
const error_1 = require("./error");
const borsh_1 = require("@race-foundation/borsh");
class SettleOp {
}
exports.SettleOp = SettleOp;
let SettleAdd = class SettleAdd extends SettleOp {
    constructor(fields) {
        super();
        Object.assign(this, fields);
    }
};
__decorate([
    (0, borsh_1.field)('u64')
], SettleAdd.prototype, "amount", void 0);
SettleAdd = __decorate([
    (0, borsh_1.variant)(0)
], SettleAdd);
exports.SettleAdd = SettleAdd;
let SettleSub = class SettleSub extends SettleOp {
    constructor(fields) {
        super();
        Object.assign(this, fields);
    }
};
__decorate([
    (0, borsh_1.field)('u64')
], SettleSub.prototype, "amount", void 0);
SettleSub = __decorate([
    (0, borsh_1.variant)(1)
], SettleSub);
exports.SettleSub = SettleSub;
let SettleEject = class SettleEject extends SettleOp {
    constructor(_) {
        super();
    }
};
SettleEject = __decorate([
    (0, borsh_1.variant)(2)
], SettleEject);
exports.SettleEject = SettleEject;
class Settle {
    constructor(fields) {
        this.addr = fields.addr;
        this.op = fields.op;
    }
    sortKey() {
        if (this.op instanceof SettleAdd) {
            return 0;
        }
        else if (this.op instanceof SettleSub) {
            return 1;
        }
        else {
            return 2;
        }
    }
    compare(s) {
        return this.sortKey() - s.sortKey();
    }
}
__decorate([
    (0, borsh_1.field)('string')
], Settle.prototype, "addr", void 0);
__decorate([
    (0, borsh_1.field)((0, borsh_1.enums)(SettleOp))
], Settle.prototype, "op", void 0);
exports.Settle = Settle;
class Ask {
    constructor(fields) {
        Object.assign(this, fields);
    }
}
__decorate([
    (0, borsh_1.field)('string')
], Ask.prototype, "playerAddr", void 0);
exports.Ask = Ask;
class Assign {
    constructor(fields) {
        Object.assign(this, fields);
    }
}
__decorate([
    (0, borsh_1.field)('usize')
], Assign.prototype, "randomId", void 0);
__decorate([
    (0, borsh_1.field)('string')
], Assign.prototype, "playerAddr", void 0);
__decorate([
    (0, borsh_1.field)((0, borsh_1.array)('usize'))
], Assign.prototype, "indexes", void 0);
exports.Assign = Assign;
class Reveal {
    constructor(fields) {
        Object.assign(this, fields);
    }
}
__decorate([
    (0, borsh_1.field)('usize')
], Reveal.prototype, "randomId", void 0);
__decorate([
    (0, borsh_1.field)((0, borsh_1.array)('usize'))
], Reveal.prototype, "indexes", void 0);
exports.Reveal = Reveal;
class Release {
    constructor(fields) {
        Object.assign(this, fields);
    }
}
__decorate([
    (0, borsh_1.field)('usize')
], Release.prototype, "decisionId", void 0);
exports.Release = Release;
class ActionTimeout {
    constructor(fields) {
        Object.assign(this, fields);
    }
}
__decorate([
    (0, borsh_1.field)('string')
], ActionTimeout.prototype, "playerAddr", void 0);
__decorate([
    (0, borsh_1.field)('u64')
], ActionTimeout.prototype, "timeout", void 0);
exports.ActionTimeout = ActionTimeout;
class Effect {
    constructor(fields) {
        Object.assign(this, fields);
    }
    static fromContext(context) {
        const revealed = new Map();
        for (const st of context.randomStates) {
            revealed.set(st.id, st.revealed);
        }
        const answered = new Map();
        for (const st of context.decisionStates) {
            answered.set(st.id, st.value);
        }
        const actionTimeout = undefined;
        const waitTimeout = undefined;
        const startGame = false;
        const stopGame = false;
        const cancelDispatch = false;
        const timestamp = context.timestamp;
        const currRandomId = context.randomStates.length + 1;
        const currDecisionId = context.decisionStates.length + 1;
        const playersCount = context.players.length;
        const serversCount = context.servers.length;
        const asks = [];
        const assigns = [];
        const releases = [];
        const reveals = [];
        const initRandomStates = [];
        const settles = [];
        const handlerState = context.handlerState;
        const error = undefined;
        const allowExit = context.allowExit;
        return new Effect({
            actionTimeout,
            waitTimeout,
            startGame,
            stopGame,
            cancelDispatch,
            timestamp,
            currRandomId,
            currDecisionId,
            playersCount,
            serversCount,
            asks,
            assigns,
            releases,
            reveals,
            initRandomStates,
            revealed,
            answered,
            settles,
            handlerState,
            error,
            allowExit,
        });
    }
}
__decorate([
    (0, borsh_1.field)((0, borsh_1.option)((0, borsh_1.struct)(ActionTimeout)))
], Effect.prototype, "actionTimeout", void 0);
__decorate([
    (0, borsh_1.field)((0, borsh_1.option)('u64'))
], Effect.prototype, "waitTimeout", void 0);
__decorate([
    (0, borsh_1.field)('bool')
], Effect.prototype, "startGame", void 0);
__decorate([
    (0, borsh_1.field)('bool')
], Effect.prototype, "stopGame", void 0);
__decorate([
    (0, borsh_1.field)('bool')
], Effect.prototype, "cancelDispatch", void 0);
__decorate([
    (0, borsh_1.field)('u64')
], Effect.prototype, "timestamp", void 0);
__decorate([
    (0, borsh_1.field)('usize')
], Effect.prototype, "currRandomId", void 0);
__decorate([
    (0, borsh_1.field)('usize')
], Effect.prototype, "currDecisionId", void 0);
__decorate([
    (0, borsh_1.field)('u16')
], Effect.prototype, "playersCount", void 0);
__decorate([
    (0, borsh_1.field)('u16')
], Effect.prototype, "serversCount", void 0);
__decorate([
    (0, borsh_1.field)((0, borsh_1.array)((0, borsh_1.struct)(Ask)))
], Effect.prototype, "asks", void 0);
__decorate([
    (0, borsh_1.field)((0, borsh_1.array)((0, borsh_1.struct)(Assign)))
], Effect.prototype, "assigns", void 0);
__decorate([
    (0, borsh_1.field)((0, borsh_1.array)((0, borsh_1.struct)(Reveal)))
], Effect.prototype, "reveals", void 0);
__decorate([
    (0, borsh_1.field)((0, borsh_1.array)((0, borsh_1.struct)(Release)))
], Effect.prototype, "releases", void 0);
__decorate([
    (0, borsh_1.field)((0, borsh_1.array)((0, borsh_1.enums)(random_state_1.RandomSpec)))
], Effect.prototype, "initRandomStates", void 0);
__decorate([
    (0, borsh_1.field)((0, borsh_1.map)('usize', (0, borsh_1.map)('usize', 'string')))
], Effect.prototype, "revealed", void 0);
__decorate([
    (0, borsh_1.field)((0, borsh_1.map)('usize', 'string'))
], Effect.prototype, "answered", void 0);
__decorate([
    (0, borsh_1.field)((0, borsh_1.array)((0, borsh_1.struct)(Settle)))
], Effect.prototype, "settles", void 0);
__decorate([
    (0, borsh_1.field)((0, borsh_1.option)('u8-array'))
], Effect.prototype, "handlerState", void 0);
__decorate([
    (0, borsh_1.field)((0, borsh_1.option)((0, borsh_1.enums)(error_1.HandleError)))
], Effect.prototype, "error", void 0);
__decorate([
    (0, borsh_1.field)('bool')
], Effect.prototype, "allowExit", void 0);
exports.Effect = Effect;
//# sourceMappingURL=effect.js.map