export declare abstract class HandleError extends Error {
}
export declare class CustomError extends HandleError {
    message: string;
    constructor(fields: {
        message: string;
    });
}
export declare class NoEnoughPlayers extends HandleError {
    constructor(_: any);
}
export declare class PlayerNotInGame extends HandleError {
    constructor(_: any);
}
export declare class CantLeave extends HandleError {
    constructor(_: any);
}
export declare class InvalidAmount extends HandleError {
    constructor(_: any);
}
export declare class MalformedGameAccountData extends HandleError {
    constructor(_: any);
}
export declare class MalformedCustomEvent extends HandleError {
    constructor(_: any);
}
export declare class SerializationError extends HandleError {
    constructor(_: any);
}
export declare class NoEnoughServers extends HandleError {
    constructor(_: any);
}
export declare class InternalError extends HandleError {
    message: string;
    constructor(fields: {
        message: string;
    });
}
export declare class SdkError extends Error {
    constructor(message: string);
    static publicKeyNotFound(addr: string): SdkError;
    static gameAccountNotFound(addr: string): SdkError;
    static gameBundleNotFound(addr: string): SdkError;
    static transactorAccountNotFound(addr: string): SdkError;
    static gameNotServed(addr: string): SdkError;
    static tokenNotFound(addr: string): SdkError;
}
