"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Shutdown = exports.SecretsReady = exports.AnswerDecision = exports.ActionTimeout = exports.DrawTimeout = exports.DrawRandomItems = exports.WaitingTimeout = exports.GameStart = exports.Leave = exports.ServerLeave = exports.Sync = exports.RandomnessReady = exports.Lock = exports.CiphertextAndDigest = exports.Mask = exports.OperationTimeout = exports.ShareSecrets = exports.Ready = exports.makeCustomEvent = exports.Custom = exports.GameEvent = exports.Answer = exports.Random = exports.SecretShare = void 0;
const borsh_1 = require("@race-foundation/borsh");
const accounts_1 = require("./accounts");
class SecretShare {
}
exports.SecretShare = SecretShare;
let Random = class Random extends SecretShare {
    constructor(fields) {
        super();
        Object.assign(this, fields);
    }
};
__decorate([
    (0, borsh_1.field)('string')
], Random.prototype, "fromAddr", void 0);
__decorate([
    (0, borsh_1.field)((0, borsh_1.option)('string'))
], Random.prototype, "toAddr", void 0);
__decorate([
    (0, borsh_1.field)('usize')
], Random.prototype, "randomId", void 0);
__decorate([
    (0, borsh_1.field)('usize')
], Random.prototype, "index", void 0);
__decorate([
    (0, borsh_1.field)('u8-array')
], Random.prototype, "secret", void 0);
Random = __decorate([
    (0, borsh_1.variant)(0)
], Random);
exports.Random = Random;
let Answer = class Answer extends SecretShare {
    constructor(fields) {
        super();
        Object.assign(this, fields);
    }
};
__decorate([
    (0, borsh_1.field)('string')
], Answer.prototype, "fromAddr", void 0);
__decorate([
    (0, borsh_1.field)('usize')
], Answer.prototype, "decisionId", void 0);
__decorate([
    (0, borsh_1.field)('u8-array')
], Answer.prototype, "secret", void 0);
Answer = __decorate([
    (0, borsh_1.variant)(1)
], Answer);
exports.Answer = Answer;
class GameEvent {
    kind() {
        return 'Invalid';
    }
}
exports.GameEvent = GameEvent;
let Custom = class Custom extends GameEvent {
    constructor(fields) {
        super();
        Object.assign(this, fields);
    }
    kind() {
        return 'Custom';
    }
};
__decorate([
    (0, borsh_1.field)('string')
], Custom.prototype, "sender", void 0);
__decorate([
    (0, borsh_1.field)('u8-array')
], Custom.prototype, "raw", void 0);
Custom = __decorate([
    (0, borsh_1.variant)(0)
], Custom);
exports.Custom = Custom;
function makeCustomEvent(sender, customEvent) {
    return new Custom({
        sender,
        raw: customEvent.serialize(),
    });
}
exports.makeCustomEvent = makeCustomEvent;
let Ready = class Ready extends GameEvent {
    constructor(_ = {}) {
        super();
    }
    kind() {
        return 'Ready';
    }
};
Ready = __decorate([
    (0, borsh_1.variant)(1)
], Ready);
exports.Ready = Ready;
let ShareSecrets = class ShareSecrets extends GameEvent {
    constructor(fields) {
        super();
        Object.assign(this, fields);
    }
    kind() {
        return 'ShareSecrets';
    }
};
__decorate([
    (0, borsh_1.field)('string')
], ShareSecrets.prototype, "sender", void 0);
__decorate([
    (0, borsh_1.field)((0, borsh_1.array)((0, borsh_1.enums)(SecretShare)))
], ShareSecrets.prototype, "shares", void 0);
ShareSecrets = __decorate([
    (0, borsh_1.variant)(2)
], ShareSecrets);
exports.ShareSecrets = ShareSecrets;
let OperationTimeout = class OperationTimeout extends GameEvent {
    constructor(fields) {
        super();
        Object.assign(this, fields);
    }
    kind() {
        return 'OperationTimeout';
    }
};
__decorate([
    (0, borsh_1.field)((0, borsh_1.array)('string'))
], OperationTimeout.prototype, "addrs", void 0);
OperationTimeout = __decorate([
    (0, borsh_1.variant)(3)
], OperationTimeout);
exports.OperationTimeout = OperationTimeout;
let Mask = class Mask extends GameEvent {
    constructor(fields) {
        super();
        Object.assign(this, fields);
    }
    kind() {
        return 'Mask';
    }
};
__decorate([
    (0, borsh_1.field)('string')
], Mask.prototype, "sender", void 0);
__decorate([
    (0, borsh_1.field)('usize')
], Mask.prototype, "randomId", void 0);
__decorate([
    (0, borsh_1.field)((0, borsh_1.array)('u8-array'))
], Mask.prototype, "ciphertexts", void 0);
Mask = __decorate([
    (0, borsh_1.variant)(4)
], Mask);
exports.Mask = Mask;
class CiphertextAndDigest {
    constructor(fields) {
        Object.assign(this, fields);
    }
}
__decorate([
    (0, borsh_1.field)('u8-array')
], CiphertextAndDigest.prototype, "ciphertext", void 0);
__decorate([
    (0, borsh_1.field)('u8-array')
], CiphertextAndDigest.prototype, "digest", void 0);
exports.CiphertextAndDigest = CiphertextAndDigest;
let Lock = class Lock extends GameEvent {
    constructor(fields) {
        super();
        Object.assign(this, fields);
    }
    kind() {
        return 'Lock';
    }
};
__decorate([
    (0, borsh_1.field)('string')
], Lock.prototype, "sender", void 0);
__decorate([
    (0, borsh_1.field)('usize')
], Lock.prototype, "randomId", void 0);
__decorate([
    (0, borsh_1.field)((0, borsh_1.array)((0, borsh_1.struct)(CiphertextAndDigest)))
], Lock.prototype, "ciphertextsAndDigests", void 0);
Lock = __decorate([
    (0, borsh_1.variant)(5)
], Lock);
exports.Lock = Lock;
let RandomnessReady = class RandomnessReady extends GameEvent {
    constructor(fields) {
        super();
        Object.assign(this, fields);
    }
    kind() {
        return 'RandomnessReady';
    }
};
__decorate([
    (0, borsh_1.field)('usize')
], RandomnessReady.prototype, "randomId", void 0);
RandomnessReady = __decorate([
    (0, borsh_1.variant)(6)
], RandomnessReady);
exports.RandomnessReady = RandomnessReady;
let Sync = class Sync extends GameEvent {
    constructor(fields) {
        super();
        Object.assign(this, fields);
    }
    kind() {
        return 'Sync';
    }
};
__decorate([
    (0, borsh_1.field)((0, borsh_1.array)((0, borsh_1.struct)(accounts_1.PlayerJoin)))
], Sync.prototype, "newPlayers", void 0);
__decorate([
    (0, borsh_1.field)((0, borsh_1.array)((0, borsh_1.struct)(accounts_1.ServerJoin)))
], Sync.prototype, "newServers", void 0);
__decorate([
    (0, borsh_1.field)('string')
], Sync.prototype, "transactorAddr", void 0);
__decorate([
    (0, borsh_1.field)('u64')
], Sync.prototype, "accessVersion", void 0);
Sync = __decorate([
    (0, borsh_1.variant)(7)
], Sync);
exports.Sync = Sync;
let ServerLeave = class ServerLeave extends GameEvent {
    constructor(fields) {
        super();
        Object.assign(this, fields);
    }
    kind() {
        return 'ServerLeave';
    }
};
__decorate([
    (0, borsh_1.field)('string')
], ServerLeave.prototype, "serverAddr", void 0);
__decorate([
    (0, borsh_1.field)('string')
], ServerLeave.prototype, "transactorAddr", void 0);
ServerLeave = __decorate([
    (0, borsh_1.variant)(8)
], ServerLeave);
exports.ServerLeave = ServerLeave;
let Leave = class Leave extends GameEvent {
    constructor(fields) {
        super();
        Object.assign(this, fields);
    }
    kind() {
        return 'Leave';
    }
};
__decorate([
    (0, borsh_1.field)('string')
], Leave.prototype, "playerAddr", void 0);
Leave = __decorate([
    (0, borsh_1.variant)(9)
], Leave);
exports.Leave = Leave;
let GameStart = class GameStart extends GameEvent {
    constructor(fields) {
        super();
        Object.assign(this, fields);
    }
    kind() {
        return 'GameStart';
    }
};
__decorate([
    (0, borsh_1.field)('u64')
], GameStart.prototype, "accessVersion", void 0);
GameStart = __decorate([
    (0, borsh_1.variant)(10)
], GameStart);
exports.GameStart = GameStart;
let WaitingTimeout = class WaitingTimeout extends GameEvent {
    constructor(_ = {}) {
        super();
    }
    kind() {
        return 'WaitingTimeout';
    }
};
WaitingTimeout = __decorate([
    (0, borsh_1.variant)(11)
], WaitingTimeout);
exports.WaitingTimeout = WaitingTimeout;
let DrawRandomItems = class DrawRandomItems extends GameEvent {
    constructor(fields) {
        super();
        Object.assign(this, fields);
    }
    kind() {
        return 'DrawRandomItems';
    }
};
__decorate([
    (0, borsh_1.field)('string')
], DrawRandomItems.prototype, "sender", void 0);
__decorate([
    (0, borsh_1.field)('usize')
], DrawRandomItems.prototype, "randomId", void 0);
__decorate([
    (0, borsh_1.field)((0, borsh_1.array)('usize'))
], DrawRandomItems.prototype, "indexes", void 0);
DrawRandomItems = __decorate([
    (0, borsh_1.variant)(12)
], DrawRandomItems);
exports.DrawRandomItems = DrawRandomItems;
let DrawTimeout = class DrawTimeout extends GameEvent {
    constructor(_) {
        super();
    }
    kind() {
        return 'DrawTimeout';
    }
};
DrawTimeout = __decorate([
    (0, borsh_1.variant)(13)
], DrawTimeout);
exports.DrawTimeout = DrawTimeout;
let ActionTimeout = class ActionTimeout extends GameEvent {
    constructor(fields) {
        super();
        Object.assign(this, fields);
    }
    kind() {
        return 'ActionTimeout';
    }
};
__decorate([
    (0, borsh_1.field)('string')
], ActionTimeout.prototype, "playerAddr", void 0);
ActionTimeout = __decorate([
    (0, borsh_1.variant)(14)
], ActionTimeout);
exports.ActionTimeout = ActionTimeout;
let AnswerDecision = class AnswerDecision extends GameEvent {
    constructor(fields) {
        super();
        Object.assign(this, fields);
    }
    kind() {
        return 'AnswerDecision';
    }
};
__decorate([
    (0, borsh_1.field)('string')
], AnswerDecision.prototype, "sender", void 0);
__decorate([
    (0, borsh_1.field)('usize')
], AnswerDecision.prototype, "decisionId", void 0);
__decorate([
    (0, borsh_1.field)('u8-array')
], AnswerDecision.prototype, "ciphertext", void 0);
__decorate([
    (0, borsh_1.field)('u8-array')
], AnswerDecision.prototype, "digest", void 0);
AnswerDecision = __decorate([
    (0, borsh_1.variant)(15)
], AnswerDecision);
exports.AnswerDecision = AnswerDecision;
let SecretsReady = class SecretsReady extends GameEvent {
    constructor(fields) {
        super();
        Object.assign(this, fields);
    }
    kind() {
        return 'SecretsReady';
    }
};
__decorate([
    (0, borsh_1.field)((0, borsh_1.array)('usize'))
], SecretsReady.prototype, "randomIds", void 0);
SecretsReady = __decorate([
    (0, borsh_1.variant)(16)
], SecretsReady);
exports.SecretsReady = SecretsReady;
let Shutdown = class Shutdown extends GameEvent {
    constructor(_ = {}) {
        super();
    }
    kind() {
        return 'Shutdown';
    }
};
Shutdown = __decorate([
    (0, borsh_1.variant)(17)
], Shutdown);
exports.Shutdown = Shutdown;
//# sourceMappingURL=events.js.map