"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GameContextSnapshot = exports.ServerShapshot = exports.PlayerShapshot = void 0;
class PlayerShapshot {
    constructor(o) {
        this.addr = o.addr;
        this.balance = o.balance;
        this.position = o.position;
        this.status = o.status;
    }
}
exports.PlayerShapshot = PlayerShapshot;
class ServerShapshot {
    constructor(o) {
        this.addr = o.addr;
        this.endpoint = o.endpoint;
        this.status = o.status;
    }
}
exports.ServerShapshot = ServerShapshot;
class GameContextSnapshot {
    constructor(context) {
        this.gameAddr = context.gameAddr;
        this.accessVersion = context.accessVersion;
        this.settleVersion = context.settleVersion;
        this.status = context.status;
        this.allowExit = context.allowExit;
        this.players = context.players.map(p => new PlayerShapshot(p));
        this.servers = context.servers.map(s => new ServerShapshot(s));
    }
}
exports.GameContextSnapshot = GameContextSnapshot;
//# sourceMappingURL=game-context-snapshot.js.map