var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { field, variant } from '@race-foundation/borsh';
export class HandleError extends Error {
}
let CustomError = class CustomError extends HandleError {
    constructor(fields) {
        super();
        this.message = fields.message;
    }
};
CustomError = __decorate([
    variant(0)
], CustomError);
export { CustomError };
let NoEnoughPlayers = class NoEnoughPlayers extends HandleError {
    constructor(_) {
        super();
        this.message = 'No enough players';
    }
};
NoEnoughPlayers = __decorate([
    variant(1)
], NoEnoughPlayers);
export { NoEnoughPlayers };
let PlayerNotInGame = class PlayerNotInGame extends HandleError {
    constructor(_) {
        super();
        this.message = 'Player not in game';
    }
};
PlayerNotInGame = __decorate([
    variant(2)
], PlayerNotInGame);
export { PlayerNotInGame };
let CantLeave = class CantLeave extends HandleError {
    constructor(_) {
        super();
        this.message = "Can't leave game";
    }
};
CantLeave = __decorate([
    variant(3)
], CantLeave);
export { CantLeave };
let InvalidAmount = class InvalidAmount extends HandleError {
    constructor(_) {
        super();
        this.message = 'Invalid amount';
    }
};
InvalidAmount = __decorate([
    variant(4)
], InvalidAmount);
export { InvalidAmount };
let MalformedGameAccountData = class MalformedGameAccountData extends HandleError {
    constructor(_) {
        super();
        this.message = 'Malformed game account data';
    }
};
MalformedGameAccountData = __decorate([
    variant(5)
], MalformedGameAccountData);
export { MalformedGameAccountData };
let MalformedCustomEvent = class MalformedCustomEvent extends HandleError {
    constructor(_) {
        super();
        this.message = 'Malformed custom event';
    }
};
MalformedCustomEvent = __decorate([
    variant(6)
], MalformedCustomEvent);
export { MalformedCustomEvent };
let SerializationError = class SerializationError extends HandleError {
    constructor(_) {
        super();
        this.message = 'Serilization error';
    }
};
SerializationError = __decorate([
    variant(7)
], SerializationError);
export { SerializationError };
let NoEnoughServers = class NoEnoughServers extends HandleError {
    constructor(_) {
        super();
        this.message = 'No enough servers';
    }
};
NoEnoughServers = __decorate([
    variant(8)
], NoEnoughServers);
export { NoEnoughServers };
let InternalError = class InternalError extends HandleError {
    constructor(fields) {
        super();
        this.message = `Internal error: ${fields.message}`;
    }
};
__decorate([
    field('string')
], InternalError.prototype, "message", void 0);
InternalError = __decorate([
    variant(9)
], InternalError);
export { InternalError };
export class SdkError extends Error {
    constructor(message) {
        super(message);
    }
    static publicKeyNotFound(addr) {
        return new SdkError(`RSA public key for ${addr} is missing`);
    }
    static gameAccountNotFound(addr) {
        return new SdkError(`Game account of ${addr} not found`);
    }
    static gameBundleNotFound(addr) {
        return new SdkError(`Game bundle of ${addr} not found`);
    }
    static transactorAccountNotFound(addr) {
        return new SdkError(`Transactor's account of ${addr} not found`);
    }
    static gameNotServed(addr) {
        return new SdkError(`Game at ${addr} is not served`);
    }
    static tokenNotFound(addr) {
        return new SdkError(`Token ${addr} not found`);
    }
}
//# sourceMappingURL=error.js.map