import { Ciphertext, Digest, Id, Secret } from './types';
export type DecisionStatus = 'asked' | 'answered' | 'releasing' | 'released';
export declare class Answer {
    digest: Digest;
    ciphertext: Ciphertext;
    constructor(ciphertext: Ciphertext, digest: Digest);
}
export declare class DecisionState {
    id: Id;
    owner: string;
    status: DecisionStatus;
    answer: Answer | undefined;
    secret: Secret | undefined;
    value: string | undefined;
    constructor(id: Id, owner: string);
    setAnswer(owner: string, ciphertext: Ciphertext, digest: Digest): void;
    release(): void;
    addReleased(value: string): void;
    addSecret(owner: string, secret: Secret): void;
}
//# sourceMappingURL=decision-state.d.ts.map