import { PlayerProfile } from './accounts';
import { GameContext, GameStatus, IPlayer, IServer, NodeStatus } from './game-context';
export declare class PlayerShapshot {
    readonly addr: string;
    readonly position: number;
    readonly balance: bigint;
    readonly status: NodeStatus;
    profile?: PlayerProfile;
    constructor(o: IPlayer);
}
export declare class ServerShapshot {
    readonly addr: string;
    readonly endpoint: string;
    readonly status: NodeStatus;
    constructor(o: IServer);
}
export declare class GameContextSnapshot {
    readonly gameAddr: string;
    readonly accessVersion: bigint;
    readonly settleVersion: bigint;
    readonly status: GameStatus;
    readonly allowExit: boolean;
    readonly players: PlayerShapshot[];
    readonly servers: ServerShapshot[];
    constructor(context: GameContext);
}
//# sourceMappingURL=game-context-snapshot.d.ts.map